#!/bin/bash

./MieTool 360e-9 1.35 1e-4 sr 1e-6 18000 > test.txt

gnuplot<<GNUPLOT

set terminal postscript enhanced eps color font "courier,bold,13"
set out "test.eps"

#set xlabel "angle [{/Symbol m}=cos({/Symbol v})]"
#set ylabel "phase function [1/sr]"

unset border
unset xlabel
unset ylabel
unset xtics
unset ytics

set multiplot layout 2,2

set polar
set title "P_{11}"
plot './test.txt' u (acos(\$1)):2 w l lt 1 lc 1 notitle, './test.txt' u (-acos(\$1)):2 w l lt 1 lc 1 notitle

set title "P_{12}/P_{11}"
plot './test.txt' u (acos(\$1)):(\$3/\$2) w l lt 1 lc 2 notitle, './test.txt' u (-acos(\$1)):(\$3/\$2) w l lt 1 lc 2 notitle

set title "P_{33}/P_{11}"
plot './test.txt' u (acos(\$1)):(\$4/\$2) w l lt 1 lc 3 notitle, './test.txt' u (-acos(\$1)):(\$4/\$2) w l lt 1 lc 3 notitle

set title "P_{34}/P_{11}"
plot './test.txt' u (acos(\$1)):(\$5/\$2) w l lt 1 lc 4 notitle, './test.txt' u (-acos(\$1)):(\$5/\$2) w l lt 1 lc 4 notitle

GNUPLOT

gv test.eps &
