1;

function mu=sampleMuRayleigh(p)
	A=135.0;
	B=270.0;
	C=0.0;
	N=180.0;
	z1=(N*(3.0-6.0*p))/(2.0*A);
	z2=(A+C)/A;
	a=(z1*z1+z2*z2*z2)^0.5;
	mu=(a-z1)^(1.0/3.0)-(a+z1)^(1.0/3.0);
end

function p=Rayleigh(mu)
	A=135.0;
	N=180.0;
	p=(A*(1.0+mu*mu))/N;
end

no_samples=20000
N=10
while(1)

	c=zeros(N+1,1);

	for i=1:no_samples
		mu=-1+2*rand;
		for j=0:N
			c(j+1)+=legendre_Pl(j, mu)*Rayleigh(mu)*(2*j+1)^0.5;
		end
	end

	c/=no_samples;

	% print result
	mu=[-1:0.01:1];
	M=length(mu);
	P=zeros(M,1);
	result=zeros(M,3);

	for i=1:M
		r=0;
		x=mu(i);
		for j=0:N
			r+=c(j+1)*legendre_Pl(j, x)*(2*j+1)^0.5;
		end
		result(i,1)=x;
		result(i,2)=Rayleigh(x);
		result(i,3)=r;
	end
	writeMatrixToFile(result, "RayleighExpansion.txt");
end



