#ifndef _Y_h
#define _Y_h	1

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
  
#include <stdio.h>
#include <stdlib.h>

#define STATE_MASK_SHIFT	0x1
#define STATE_MASK_CAPS		0x2
#define STATE_MASK_CTRL		0x4
#define STATE_MASK_ALT		0x8
#define STATE_MASK_NUM		0x20
#define STATE_MASK_RES1		0x40
#define STATE_MASK_WINDOWS	0x80
#define STATE_MASK_RES2		0x100
#define STATE_MASK_LEFT_BTN	0x100
#define STATE_MASK_MIDDLE_BTN	0x200
#define STATE_MASK_RIGHT_BTN	0x400

class YWindow;

class Y
{
	int screen;
	unsigned int display_width, display_height;
	Display *display;
	
	// global window list
	class YWindow **pYWindow;
	int no_windows;

	void closeWindows();
	bool openDisplay(char *display_name);
	//inline void closeDisplay(){XCloseDisplay(display);}
public:
	Y();
	Y(char *display_name);
	~Y();

	bool registerWindow(class YWindow *YWindowPtr);
	bool processSystemEvents();

	// inlines...
	inline Display *getDisplayPtr(){return display;}
	inline int getScreen(){return screen;}

	inline unsigned long YBlackPixel(){return XBlackPixel(display, screen);}
	inline unsigned long YWhitePixel(){return XWhitePixel(display, screen);}
};

#endif //_Y_h

