#include "YImage.h"

YImage::YImage()
{
	pXImage=(XImage *)0;
}

YImage::~YImage()
{
	if(pXImage)
	{
		XDestroyImage(pXImage);
		pXImage=(XImage *)0;
	}
}

bool YImage::setSize(int xres, int yres, int pixel_size)
{
	if(pXImage)
	{
		XDestroyImage(pXImage);
		pXImage=(XImage *)0;
	}
	if(!(data=malloc(xres*yres*pixel_size)))
	{
		fprintf(stderr,"unable to allocate memory for XImage data with resolution %dx%d...\n", xres, yres);
		return false;
	}
	int depth=XDefaultDepth(pDisplay, screen);
	pXImage=XCreateImage(pDisplay, pVisual, depth, ZPixmap, 0, (char *) data, xres, yres, 8*pixel_size, 0); //xres*pixel_size=0
	return (pXImage) && (XInitImage(pXImage));
}

void YImage::putImage(class YWindow *pYWindow, int x, int y)
{
	Window& window=pYWindow->getWindow();
	GC& gc=pYWindow->getGC();
	XPutImage(pDisplay, window, gc, pXImage, 0, 0, x, y, pXImage->width, pXImage->height);
}


