#ifndef _YWindow_h
#define _YWindow_h	1

#include "Y.h"
#include "YObject.h"

class YWindow: protected YObject
{
	bool created;
protected:
	Window window;
	XSizeHints SizeHints;

	// GC functions
	XGCValues GCvalues;
	GC gc;
	bool gc_valid;

	// unsigned int width, height;
	char window_name[100];
	bool keep_open;
public:
	YWindow();
	virtual ~YWindow();
	bool createSimpleWindow(const char *window_name,\
			int x, int y, unsigned int width, unsigned int height, unsigned int border_width,\
			unsigned long border, unsigned long background);
	void removeEventFromQueue(XEvent *pEvent);

	void setWindowTitle(const char *title);
	void setClassName(const char *res_name, const char *res_class);

	// virtual interface
	virtual bool processEvent(XEvent *pEvent);

 	virtual void OnCreateWindow(){}
	virtual bool OnConfigureNotify(XConfigureEvent *pXConfigureEvent){return false;}
	virtual bool OnResize(XResizeRequestEvent *pXResizeRequestEvent){return false;}
	virtual bool OnExpose(XExposeEvent *pXExposeEvent){return false;}
	virtual bool OnMotion(XMotionEvent *pXMotionEvent){return false;}
	virtual bool OnKeyPress(XKeyPressedEvent *pXKeyPressedEvent){return false;}
	virtual bool OnButtonPress(XButtonPressedEvent *pXButtonPressedEvent){return false;}
	virtual bool OnButtonRelease(XButtonReleasedEvent *pXButtonReleasedEvent){return false;}
	virtual void OnDestroyWindow(){}
	
	// inlines
	inline void selectInput(long event_mask){XSelectInput(pDisplay, window, event_mask);}
	inline void setStandardProperties(char *icon_name, Pixmap icon_pixmap, char **argv, int argc, XSizeHints *hints)
		{XSetStandardProperties(pDisplay, window, window_name, icon_name, icon_pixmap, argv, argc, &SizeHints);}
	inline bool keepOpen(){return keep_open;}
	inline GC& getGC(){return gc;}
	inline Window& getWindow(){return window;}


};

#endif // _YWindow_h

